﻿using System;
using System.Collections;
using System.IO;
using Saxon.Api;

namespace SaxonFunctionOverrideRepro {

   class Program {

      static void Main(string[] args) {

         var proc = new Processor();
         proc.RegisterExtensionFunction(new FooFunctionDefinition());

         var compiler = proc.NewXsltCompiler();
         compiler.ErrorList = new ArrayList();

         XsltTransformer transform;

         using (var source = File.OpenRead("XSLTFile1.xslt")) {
            transform = compiler.Compile(source).Load();
         }

         var serializer = new Serializer();
         serializer.SetOutputWriter(Console.Out);

         transform.InitialTemplate = new QName("main");
         transform.Run(serializer);

         Console.ReadLine();
      }
   }

   class FooFunctionDefinition : ExtensionFunctionDefinition {

      public override QName FunctionName { get; } = new QName("http://localhost/", "foo");

      public override int MinimumNumberOfArguments => 0;

      public override int MaximumNumberOfArguments => 0;

      public override XdmSequenceType[] ArgumentTypes { get; } = new XdmSequenceType[0];

      public override ExtensionFunctionCall MakeFunctionCall() {
         return new FunctionCall();
      }

      public override XdmSequenceType ResultType(XdmSequenceType[] ArgumentTypes) {
         return new XdmSequenceType(XdmAtomicType.BuiltInAtomicType(QName.XS_STRING), ' ');
      }

      class FunctionCall : ExtensionFunctionCall {

         public override IXdmEnumerator Call(IXdmEnumerator[] arguments, DynamicContext context) {
            return (IXdmEnumerator)new XdmAtomicValue("extension").GetEnumerator();
         }
      }
   }
}
